************************************************************************
* CAL.prg  06/16/92
************************************************************************
&& this program displays a calendar and allows the user to select a date
parameter dte
dfl = "calendar"
set procedure to &dfl
&& save settings for later restoration
save_escap = iifc(set('escape'), 'on', 'off')
set escape off
save_vide = vsay()
strt = .t.
if iscolor()
    colors = ' Black , Blue , Green , Cyan , Red , Purple , Yellow , White '
    color_code = 'N,B,G,BG,R,RB,GR,W'
    publ say_fore, say_back, get_fore, get_back, box_fore, box_back,;
	erase_fore, erase_back, color_stri
    do getcolors
endif
dimension pstnary[45]
rw = 0
cl = 0
up = 328
lft = 331
rgt = 333
dn = 336
esc = 27
lltrn = 78
ultrn = 110
lltrp = 80
ultrp = 112
tm = month(dte)
ty = year(dte)
dy = day(dte)
mh = tm
yr = ty
nd = .f.



STORE 'Sun Mon Tue Wed Thu Fri Sat' TO HEADING



STORE LPAD("0",STR(tm),2) TO tm
IF ty < 100
  STORE LPAD("0",STR(ty),2) TO ty
  STORE tm + '/' + '01' + '/' + '19' + ty TO strdate
ELSE
  STORE LPAD("0",STR(ty),4) TO ty
  STORE tm + '/' + '01' + '/' + ty TO strdate
ENDIF

* make first day of the month
sTORE SUBSTR(strdate,1,3) + '01' + SUBSTR(strdate,6,10) TO strdate

STORE CTOD(strdate) TO tdate      && convert to date type
pUSHWIND()
WINDOW(9,9,20,39)
erase
@ 0,1 SAY 'n: next  p: prev  esc: quit'
@ 1,0 TO 1,31 DOUBLE
@ 3,0 TO 3,31 DOUBLE

DO WHILE nd = .f.
  * Display the month and year
  @ 6, 1 clear
  STORE CMONTH(tdate) TO tmonth            && get month-string: January
  STORE '19' + SUBSTR(DTOC(tdate),7,8) TO YEAR
  @ 2,1 SAY CENTER(tmonth + ' ' + YEAR,28)
  @ 4,1 SAY CENTER(HEADING,28)
  STORE 6 TO trow
  STORE 1 TO tcol
  
  STORE tdate TO ttemp
  pstn = 1
  DO WHILE DOW(ttemp) <> 1      	&& make blank date  
    @ trow, tcol SAY  '  '
    STORE ttemp - 1 TO ttemp
    STORE tcol + 4 TO tcol
    inc pstn   
  ENDDO
  for i = 1 to 37
  pstnary[i] = '  '
  next
  STORE 1 TO tcount
  
  DO WHILE tcount < 29                   && trick to speed up by display 28 day
    pstnary[pstn] = str(tcount, 2)
    inc pstn
    @ trow, tcol SAY tcount PICTURE '99' && display dates of the month
    INC tcount, tdate
    STORE tcol + 4 TO tcol 
    IF tcol > 28                         && next week
      STORE 1 TO tcol
      INC trow
    ENDIF
  ENDDO
  
  DO WHILE CMONTH(tdate) = tmonth        && do until difference month
    @ trow, tcol SAY tcount PICTURE '99' && display dates of the month
    pstnary[pstn] = str(tcount, 2)
    inc pstn
    INC tcount, tdate
    STORE tcol + 4 TO tcol 
    IF tcol > 28                         && next week
      STORE 1 TO tcol
      INC trow
    ENDIF
  ENDDO
  rdrw = .f.
  if strt = .f.
    if month(tdate) = 1
      if pstnary[lpstn] <> '  '
         pstn = inpostn(12, val(ltrim(pstnary[lpstn])), yr)
      else
         if lpstn < 28
            pstn = inpostn(12, 1, yr)
         else
            pstn = inpostn(12, 31, yr)
         endif
      endif
    else
     if pstnary[lpstn] <> '  '
         pstn = inpostn(month(tdate) - 1, val(ltrim(pstnary[lpstn])), yr)
      else
         if lpstn < 28
            pstn = inpostn(month(tdate) - 1, 1, yr)
         else
	    pstn = inpostn(month(tdate) - 1, ltomh(month(tdate) - 1, yr), yr)
         endif
      endif
    endif
  else
    pstn = inpostn(mh + 0, dy + 0, yr + 0)
  endif
  ldom = ltomh(mh, yr)

  if iscolor()
     do setinverse
  else
     set say video to 112
  endif
  do while pstnary[pstn] = '  '
     pstn = iifn(pstn > 15, pstn - 1, pstn + 1)
  enddo
  rw = int((pstn - 1) / 7 + 6)
  cl = (pstn - 1) \ 7 * 4 + 1
  tosy = pstnary[pstn]
  @ rw, cl say tosy picture 'XX'

  do while rdrw = .f. and nd = .f.
    
    set console off
    wait
    chr = lastkey()
    set console on
    if iscolor()
       do setcolors
    else
       set say video to 7
    endif
    tosy = tosy + ' '
    @ rw, cl say tosy picture 'XXX' |turn off reverse video

    DO CASE
      case chr = up
         pstn = pstn - 7
         if pstn < 1 or pstn > 37
            pstn = pstn + 7
         else
            if pstnary[pstn] = '  '
               pstn = pstn + 7
            endif
         endif
         if iscolor()
            do setinverse
         else
            set say video to 112
         endif
         rw = int((pstn - 1) / 7 + 6)
         cl = (pstn - 1) \ 7 * 4 + 1
         tosy = pstnary[pstn]
         @ rw, cl say tosy picture 'XX'
         loop

      case chr = lft
         pstn = pstn - 1
         if pstn < 1 or pstn > 37
            pstn = pstn + 1
         else
            if pstnary[pstn] = '  '
               pstn = pstn + 1
            endif
         endif
         if iscolor()
            do setinverse
         else
            set say video to 112
         endif
         rw = int((pstn - 1) / 7 + 6)
         cl = (pstn - 1) \ 7 * 4 + 1
         tosy = pstnary[pstn]
         @ rw, cl say tosy picture 'XX'
         loop

      case chr = dn
         pstn = pstn + 7
         if pstn < 1 or pstn > 37
            pstn = pstn - 7
         else
            if pstnary[pstn] = '  '
               pstn = pstn - 7
            endif
         endif
         if iscolor()
            do setinverse
         else
            set say video to 112
         endif
         rw = int((pstn - 1) / 7 + 6)
         cl = (pstn - 1) \ 7 * 4 + 1
         tosy = pstnary[pstn]
         @ rw, cl say tosy picture 'XX'
         loop

      case chr = rgt
         pstn = pstn + 1
         if pstn < 1 or pstn > 37
            pstn = pstn - 1
         else
            if pstnary[pstn] = '  '
               pstn = pstn - 1
            endif
         endif
         if iscolor()
            do setinverse
         else
            set say video to 112
         endif
         rw = int((pstn - 1) / 7 + 6)
         cl = (pstn - 1) \ 7 * 4 + 1
         tosy = pstnary[pstn]
         @ rw, cl say tosy picture 'XX'
         loop

      case chr = 69 or chr = 101
        do case
           case month(tdate) = 1
             dte = '12'
           case month(tdate) < 11
             dte = '0' + str(month(tdate) - 1, 1)
	   otherwise
             dte = str(month(tdate) - 1, 2)
           endcase
        if val(ltrim(pstnary[pstn])) < 10
           dte = dte + '0' + right(pstnary[pstn], 1)
        else
	   dte = dte + pstnary[pstn]
        endif
	dte = dte + right(str(year(tdate), 4), 2)
	lastkey(0)
        set input to dte
        nd = .t.
        loop

      case chr = 315
          pushwind()
          frame(1)
          window(10, 45, 22, 78)
	  eras
          @ 0, 1 say  'The available keys are:'
          @ 2, 1 say  'n next month'
          @ 3, 1 say  'p previous month'
          @ 4, 1 say  'e return date'
          @ 5, 1 say  '<LtArw> cursor left'
          @ 6, 1 say  '<RtArw> cursor right'
          @ 7, 1 say  '<UpArw> cursor up'
          @ 8, 1 say  '<DnArw> cursor down'
          @ 9, 1 say  '<Esc> quit'
          @ 10, 1 say  ''
          @ 11, 1 say  'Press a key to continue . . .'
          wait to chr
          popwind()
          lastkey(0)
	  chr = 0
          loop

      case chr = esc
        nd = .t.
        loop

      case chr = lltrn or chr = ultrn && next month
        rdrw = .t.
        lpstn = pstn
        strt = .f.
        loop

      case chr = lltrp or chr = ultrp  && previous month
        store tdate - tcount - 2 to tdate
        store dtoc(tdate) to strdate      && convert to string
        store substr(strdate,1,3) + '01' + substr(strdate,6,10) to strdate
        store ctod(strdate) to tdate      && convert back to date
        lpstn = pstn
        strt = .f.
        rdrw = .t.
        loop

      otherwise
         if iscolor()
            do setinverse
         else
            set say video to 112
         endif
         @ rw, cl say tosy picture 'XX'
         loop
    endcase
 enddo


ENDDO
POPWIND()
set esca &save_escap
set say vide to save_vide
set proc to
return


proc setcolors
  && build set color string from the current smenu settings
  say_colors = extract(',', color_code, say_fore) + '/' +;
	extract(',', color_code, say_back)
  get_colors = extract(',', color_code, get_fore) + '/' +;
	extract(',', color_code, get_back)
  box_colors = extract(',', color_code, box_fore) + '/' +;
	extract(',', color_code, box_back) 
  era_colors = extract(',', color_code, erase_fore) + '/' +;
	extract(',', color_code, erase_back)
  color_stri = say_colors + ',' + get_colors + ',' + box_colors +;
	',' + era_colors
  set colo to &color_stri
  return



proc setinverse
  && build set color string from the current smenu settings
  say_colors = extract(',', color_code, say_back) + '/' +;
	extract(',', color_code, say_fore)
  get_colors = extract(',', color_code, get_back) + '/' +;
	extract(',', color_code, get_fore)
  box_colors = extract(',', color_code, box_back) + '/' +;
	extract(',', color_code, box_fore) 
  era_colors = extract(',', color_code, erase_back) + '/' +;
	extract(',', color_code, erase_fore)
  color_stri = say_colors + ',' + get_colors + ',' + box_colors +;
	',' + era_colors
  set colo to &color_stri
  return



proc getcolors
  color_stri = setcolor()
  do while srch('+', color_stri) <> 0
    color_stri = stuff(color_stri, srch('+', color_stri), 1, '')
    enddo
  color_stri = color_stri + ',' + extract(',', color_stri, 3)
  say_colors = extract(',', color_stri, 1)
  get_colors = extract(',', color_stri, 2)
  box_colors = extract(',', color_stri, 3)
  era_colors = extract(',', color_stri, 4)
  say_fore = inset(',', extract('/', say_colors, 1), color_code)
  say_back = inset(',', extract('/', say_colors, 2), color_code)
  get_fore = inset(',', extract('/', get_colors, 1), color_code)
  get_back = inset(',', extract('/', get_colors, 2), color_code)
  box_fore = inset(',', extract('/', box_colors, 1), color_code)
  box_back = inset(',', extract('/', box_colors, 2), color_code)
  erase_fore = inset(',', extract('/', era_colors, 1), color_code)
  erase_back = inset(',', extract('/', era_colors, 2), color_code)
  return



procedure inpostn
  private month, day, year
  parameters month, day, year
  rtn = 0
  rtn = rtn + day + dow(tdte(month + 0, 1, year + 0)) - 1
  return rtn



procedure tdte
  private month, day, year
  parameters month, day, year
  rtn = date()
  rtn = ctod(str(month + 0, 2) + '/' + str(day + 0, 2) + '/' + str(year + 0, 2))
  return rtn



procedure postn
  private posit, rw, cl
  parameters posit
  if iscolor()
    do setinverse
  else
    set say vide to 112
  endif
  do while pstnary[posit] = '  '
    posit = iifn(posit > 15, posit - 1, posit + 1)
    enddo
  rw = int((posit - 1 ) / 7 + 6)
  cl = (posit - 1) \ 7 * 4 + 1
  tosy = pstnary[posit]
  @ rw, cl say tosy picture 'XX'
  set console off
  wait
  ink_ret = lastkey()
  *ink_ret = inkey(0)
  set console on
  if iscolor()
    do setcolors
  else
    set say vide to 7
  endif
  tosy = tosy + ' '
  @ rw, cl say tosy picture 'XXX'
  return ink_ret



procedure rpostn
  private posit, chr, month, year
  parameters posit, chr, month, year
  rtn = 0
  chge = 0
  do case
    case chr = up
      chge = -7
    case chr = lft
      chge = -1
    case chr = dn
      chge = 7
    case chr = rgt
      chge = 1
    endcase
  posit = posit + chge
  if posit < 1 .or. posit > 37
     posit = posit - chge
  else
     if pstnary[posit] = '  '
	posit = posit - chge
     endif
  endif
  return posit



procedure ltomh
  private month, year
  parameters month, year
  day = 1
  dte = date()
  dte = tdte(month + 0, day + 0, year + 0)
  do while month = month(dte)
    day = day(dte)
    inc dte
    enddo
  return day
































