************
* tdbbr.prg
* A simple program to use dbbrowse()
* use inv.dbf and edit 4 fields 
* Key definitions
* Esc    quit
* F3	 quit
* Ctrl+W save & quit
* Ctrl+R go right field
* Ctrl+L go left field
* Return go right field
* Arrows go directions
* PgDn   next page
* PgUp   previous page
* User can define his own keys by adding the codes into the callback routine
* 08-12-93
* Versasoft Corporation
************

dele file tdbbr.pro
set proc to tdbbr

***** Control Key Definition *****
dbm_panrt = 372
dbm_panlt = 371
dbm_esc = 27
dbm_retkey = 13
dbm_ctlw = 23
dbm_f1 = 315
dbm_f10 = dbm_f1 + 9

use inv

***** declarations *****
dime option[32]
dime field_list[4], col_adr[4],picture[4]
dime edet[4], message[4], call_id[4]
public msg_callid, msg_status, msg_comm

***** initialazation *****
msg_callid = 0
msg_status = 0
msg_comm = 0

***** Field names *****
field_list[1] = upper("item")
field_list[2] = upper("qty:onhnd")
field_list[3] = upper("unitprice")
field_list[4] = upper("orderdate")

***** Field starting column *****
col_adr[1] = 20
col_adr[2] = 38
col_adr[3] = 45
col_adr[4] = 56

***** pictures for display ******
picture[1] = "XXXXXXXXXXXXXXXXX"
picture[2] = "######"
picture[3] = "#####.##"
picture[4] = "##/##/##"

***** Editing attributes *****
edet[1] = .t. | cfield editable
edet[2] = .t. | ifield editable
edet[3] = .f. | make ffield not editable
edet[4] = .t. | dfield editable

***** prompt messages *****
message[1] = "first field:character"
message[2] = "second field:integer"
message[3] = "third field:numeric"
message[4] = "fourth field:date"

***** Field callback IDs *****
call_id[1] = 100
call_id[2] = 200
call_id[3] = 300
call_id[4] = 400

***** dbbrowse array initializations *****
option[1] = 4
option[2] = 0
option[3] = "field_list"
option[4] = "col_adr"
option[5] = "picture"
option[6] = "edet"
option[7] = "message"
option[8] = "call_id"
option[9] = "msg_callid"
option[10] = "msg_status"
option[11] = "msg_comm"
option[12] = 5
option[13] = 15
option[14] = 10
option[15] = 70
option[16] = .t.
option[17] = .f.
option[18] = .f.
option[19] = 11
option[20] = .f.
option[21] = 20
option[22] = .t.
option[23] = .t.
option[24] = 0
option[25] = 0
option[26] = ""
option[27] = "call_back"
option[28] = 18 | define Ctrl+R to go right
option[29] = 12 | Ctrl+L to go left
option[30] = 61+256 | F3, to exit
option[31] = 0
option[32] = ""

***** display title line *****
@3, col_adr[1]  say "ITEM"
@3, col_adr[2]+ 3  say "QTY"
@3, col_adr[3]  say "UNITPRICE"
@3, col_adr[4]  say "ORDERDATE"

dbbrowse(option)
return

**************
proc call_back
* The actions for hitting the
* border are left for users to define
**************
msg_comm = 5  | usually just refresh the record only
do case
  case msg_status = 1  | a control key is pressed
    do process_ctrl
  case msg_status = 2  | user tried to move left
  case msg_status = 3  | user tries to move right
  case msg_status = 4  | user hit EOF trying to move down
  case msg_status = 5  | user hit BOF trying to move up
  case msg_status = 7  | The contents of the field is changed 
    msg_comm = 1
    do process_ctrl
    if msg_comm < 64 .OR. msg_comm >= 128
      msg_comm = msg_comm + 64
    endif
endcase
if errcode() <> 0
  msg_comm = 7  | an error occured, exit immediately
endif
return

**************
proc process_ctrl
* The process for control keys are 
* left open for user to define
**************
    dbm_key = lastkey()
    do case
      case dbm_key = dbm_ctlw
        flush
        commit
        msg_comm = 7
      case dbm_key = dbm_retkey
      *  do right_arrow
      case dbm_key = dbm_panrt
      *  do rightpos
      case dbm_key = dbm_panlt
      *  do leftpos
      case dbm_key = dbm_f1
      *  do help_dp
      case dbm_key = dbm_f10
      *  do menu_dp
      otherwise
      *    msg_comm = 7
    endcase
return

